############################################ EXERCICE 0 ############################################
class Personne:
    def __init__(self, nom, prenom):
        self.nom = nom
        self.prenom = prenom
    
class Amis:
    def __init__(self, un_ami, autre_ami):
        self.un_ami  = un_ami
        self.autre_ami  = autre_ami

    def ami(self, p):
        if self.un_ami == p :
            return self.autre_ami
        elif self.autre_ami == p :
            return self.un_ami
        else :
            return None
        
class Groupe:
    def __init__(self):
        self.amis = list()
        self.personnes = list()
    
    def declarer_amis(self, a, b):
        if a in self.personnes and b in self.personnes :
            self.amis.append(Amis(a,b))
            print(a.nom, a.prenom, "et", b.nom, b.prenom, "sont maintenant ami.")
        else:
            print(a.nom, a.prenom, "ou", b.nom, b.prenom, "ne font pas parti du groupe.")

    def ajouter_personne(self, p):
        if p not in self.personnes:
            self.personnes.append(p)
            print(p.prenom, p.nom,"a été ajouté au groupe...")
        else :
            print(p.prenom, p.nom, "fait déjà partie du groupe...")
        
# Tests de l'implémentation des classes
moi = Personne("J","B")
autre_moi = Personne("J","B") # Bien qu'ils possèdes les mêmes valeurs d'attributs, moi et autre_moi sont des objets différents.
pas_moi = Personne("J","C")
groupe = Groupe()
groupe.ajouter_personne(moi)
groupe.ajouter_personne(moi)
groupe.ajouter_personne(autre_moi)
groupe.declarer_amis(moi, pas_moi)
groupe.declarer_amis(moi, autre_moi)



############################################ EXERCICE 2 ############################################
import math
import turtle
from random import randint

class Point:
    def __init__(self, coord_x = 0, coord_y = 0):
        self.x = coord_x
        self.y = coord_y

    def translater(self, v):
        self.x += v.x
        self.y += v.y

    def distance(self, p2):
        return math.sqrt((p2.x - self.x)**2 + (p2.y - self.y)**2)
    
    def dessiner(self, dessin):
         dessin.croix(self)

class Segment:
         def __init__(self, point_1 , point_2):
             self.p1 = point_1
             self.p2 = point_2

         def translater(self, p):
             self.p1.translater(p)
             self.p2.translater(p)

         def milieu(self):
            return Point((self.p1.x + self.p2.x)/2, (self.p1.y + self.p2.y)/2)
         
         def dessiner(self, dessin):
            dessin.trait(self.p1, self.p2)

'''
# Question 1
p = Point(0, 0)
p1 = Point(100, 50)
s=Segment(p, p1)
m=s.milieu()
print(m.x, m.y)
'''
class Dessin:
     def __init__(self):
          turtle.speed(9)

     def croix(self, point):
          taille = 5
          turtle.penup()
          turtle.goto(point.x-taille, point.y)
          turtle.pendown()
          turtle.goto(point.x+taille, point.y)
          turtle.penup()
          turtle.goto(point.x, point.y-taille)
          turtle.pendown()
          turtle.goto(point.x, point.y+taille)
          turtle.penup()
     
     def trait(self, p0, p1):
          turtle.penup()
          turtle.goto(p0.x, p0.y)
          turtle.pendown()
          turtle.goto(p1.x, p1.y)
     
     def effacer(self): 
          turtle.clear()
     

'''  
# Question 2
mon_dessin = Dessin()
mon_dessin.croix(p)
mon_dessin.croix(p1)
mon_dessin.trait(p, p1)

# Question 3
p.dessiner(mon_dessin)
p1.dessiner(mon_dessin)
s.dessiner(mon_dessin)
m.dessiner(mon_dessin)

# Question 4
mon_dessin.effacer()
for i in range(1):
     p = Point(randint(-200, 200), randint(-200, 200))
     p1 = Point(randint(-200, 200), randint(-200, 200))
     s = Segment(p, p1)
     p.dessiner(mon_dessin)
     p1.dessiner(mon_dessin)
     s.dessiner(mon_dessin)

turtle.done()
'''

############################################ EXERCICE 3 ############################################

class Polygone:
    def __init__(self) -> None:
        self.sommets = []
        self.cotes = []

    def ajouter_cote(self, s0, s1):
        if s0 not in self.sommets :
            self.sommets.append(s0)
            print("Sommet de coordonnées", s0.x, s0.y, "ajouté.")
        if s1 not in self.sommets :
            self.sommets.append(s1)
            print("Sommet de coordonnées", s1.x, s1.y, "ajouté.")
        
        cote = Segment(s0, s1)

        self.cotes.append(cote)

    
    def translater(self, v):
        for s in self.sommets :
            s.x += v.x
            s.y += v.y
    
    def dessiner(self, dessin):
        for cote in self.cotes :
            cote.dessiner(dessin)

    


#Question 1.
#Tests de l'implémentation de la classe Polygone

triangle = Polygone()

s0 = Point(0,0)
s1 = Point(0,300)
s2 = Point(300,0)

triangle.ajouter_cote(s0, s1)
triangle.ajouter_cote(s1, s2)
triangle.ajouter_cote(s2, s0)

dessin = Dessin()

triangle.dessiner(dessin)



#Question 2.
#triangle
#------------------
#Polygone
#------------------
#sommets[s0, s1, s2]
#cotes[]
#------------------

#s0
#------------------
#Point
#------------------
#0
#0
#------------------

#s1
#------------------
#Point
#------------------
#0
#300
#------------------

#s2
#------------------
#Point
#------------------
#300
#0
#------------------


triangle.dessiner(dessin)
# La modification des coordonnées d'un point affecte aussi l'objet qui référence cet objet.


#Question 3.
vecteur = Point(100, 100)
triangle.translater(vecteur)
triangle.dessiner(dessin)

# Lors d'une transformation, il suffit de modifier uniquement les coordoonées des sommets dans la liste correspondante. 
# Sans liste de sommets, il faudrait parcourir la liste des cotes, et vérifier pour chaque paire de sommets, si l'un
# d'autres eux a déjà été modifié ou non.

turtle.done()


############################################ EXERCICE 4 ############################################

#Question 1. 

class Point:
    def __init__(self, coord_x = 0, coord_y = 0):
        self.x = coord_x
        self.y = coord_y

    def translater(self, v):
        if isinstance(v, Point):
            self.x += v.x
            self.y += v.y
        else :
            print("Erreur : l'argument est du type", type(v) ,". Il doit être du type 'Point'.")

    
    def dessiner(self, dessin):
        if isinstance(dessin, Dessin):
            dessin.croix(self)
        else :
            print("Erreur : l'argument est du type", type(dessin) ,". Il doit être du type 'Dessin'.")


class Segment:
         def __init__(self, point_1 , point_2):
            if isinstance(point_1, Point) and isinstance(point_2, Point) :
                self.p1 = point_1
                self.p2 = point_2
            else:
                 print("Erreur : les arguments passés ne sont pas du type 'Point'.")

         def translater(self, p):
            if isinstance(p, Point) :
                self.p1.translater(p)
                self.p2.translater(p)
            else:
                print("Erreur : l'argument est du type", type(p) ,". Il doit être du type 'Point'.")

         def milieu(self):
            return Point((self.p1.x + self.p2.x)/2, (self.p1.y + self.p2.y)/2)
         
         def dessiner(self, dessin):
            if isinstance(dessin, Dessin) :                
                dessin.trait(self.p1, self.p2)
            else :
                print("Erreur : l'argument est du type", type(dessin) ,". Il doit être du type 'Dessin'.")


p = Point(0,0)        
a = 1
p.translater(a)

segment = Segment(p, p)
segment = Segment(p, a)

#Question 2.

class Chien:
    def bonjour(self, animal):
        if isinstance(animal, Chien):
            print("Bonjour, ami Chien")
        elif isinstance(animal, Chat):
            print("OUAF, OUAF")
    

class Chat:
    def bonjour(self, animal):
        if isinstance(animal, Chat):
            print("Bonjour, ami Chat")        
        

chat = Chat()
chien = Chien()

chat.bonjour(chat)
chat.bonjour(chien)
chien.bonjour(chat)
chien.bonjour(chien)